<html>
<head>

<style>
body {color: #000000; font-family:verdana; font-size:x-small;}
</style>

</head>
<body bgcolor=#ffffff>

<?PHP
require_once('./lib/config.inc.php');
require_once('./lib/lib.inc.php');

function getEventXML($folder) {
	$eventxml = '';

$eventxml .= '<event><![CDATA['."\n";
$eventxml .= '<object type="application/x-shockwave-flash" width="'.PLAYER_WIDTH.'" height="'.PLAYER_HEIGHT.'"'."\n";
$eventxml .= 'data="'.PLAYLIST_DIRECTORY_URL.'xspf_player.swf?playlist_url='.rawurlencode(PLAYLIST_DIRECTORY_URL.'playlist'.$folder['xspf']).'.xspf'.'?t='.time().'">'."\n";
$eventxml .= '<param name="movie"'."\n";
$eventxml .= 'value="'.PLAYLIST_DIRECTORY_URL.'xspf_player.swf?playlist_url='.rawurlencode(PLAYLIST_DIRECTORY_URL.'playlist'.$folder['xspf']).'.xspf'.'?t='.time().'" />'."\n";
$eventxml .= '</object>'."\n";
$eventxml .= ']]></event>'."\n";

	return $eventxml;
}

function getFolderMenu(&$events, $folder) {
	$menu_item = '';

	if ($folder['has_play_lists']) {

		$show_sub_folders = false;
		foreach ($folder['subitems'] as $subitem) {
			if ($subitem['has_play_lists']) {
				$show_sub_folders = true;
			}
		}

		$menu_item = '<li>';

		if (($folder['xspf'] != '') || ($show_sub_folders)) {
			//Liked menu item
			if ($folder['xspf'] != '') {
				$events[] = getEventXML($folder);
			};
			$menu_item .= '<a href="#"'.($show_sub_folders ? ' class="sub"' : '').($folder['xspf'] != '' ? ' OnClick="dsEvents.setCurrentRowNumber('.count($events).'); return false;"' : '').'>';
		};

		$menu_item .= $folder['name'];

		if (($folder['xspf'] != '') || ($show_sub_folders)) {
			$menu_item .= '</a>';
		};


		if ($show_sub_folders) {
			$menu_item .= "\n".'<ul>'."\n";

			foreach ($folder['subitems'] as $subfolder) {
				$menu_item .= getFolderMenu($events, $subfolder);
			};

			$menu_item .= '</ul>'."\n";
		};

		$menu_item .= '</li>'."\n";
	};

	return $menu_item;
}

if (isset($_POST['scan_all'])) {
	$files = getDirFiles(PLAYLIST_DIRECTORY_PATH, 'xspf');
	foreach ($files as $file) {
		@unlink(PLAYLIST_DIRECTORY_PATH.$file);
	};

	$folders_structure = scan_dir(MP3_DIRECTORY_PATH, MP3_DIRECTORY_URL, '');

	$number_of_menu_items = 0;
	foreach($folders_structure as $folder) {
		if ($folder['has_play_lists']) {
			$number_of_menu_items++;
		};
	};


	$menu1 = '';
	$menu2 = '';
	$events = array();
	$menu_item_no = 0;
	foreach($folders_structure as $folder) {
		if ($folder['has_play_lists']) {
			$menu_item_no++;

			if ($menu_item_no <= ($number_of_menu_items / 2)) {
				$menu1 .= getFolderMenu($events, $folder);
			} else {
				$menu2 .= getFolderMenu($events, $folder);
			};
		};
	};

	$filename = PLAYLIST_DIRECTORY_PATH.'playlistmenu.htm';
	if ($handle = fopen($filename, 'w')) {
		fwrite($handle, '<li><a href="#" class="menulink">P l a y l i s t s 1</a>'."\n");
		fwrite($handle, '<ul>'."\n".$menu1.'</ul>'."\n");
		fwrite($handle, '</li>'."\n\n\n");

		fwrite($handle, '<li><a href="#" class="menulink">P l a y l i s t s 2</a>'."\n");
		fwrite($handle, '<ul>'."\n".$menu2.'</ul>'."\n");
		fwrite($handle, '</li>'."\n\n\n");

		fclose($handle);
	};

	$custom_files = getDirFiles(PLAYLIST_DIRECTORY_PATH.'playlist_custom/', 'xspf');
	$custom_pl = array();
	foreach ($custom_files as $file) {
		$file = str_replace('.xspf', '', $file);
		$custom_pl[] = array(
			'name' => $file,
			'xspf' => '_custom/'.$file,
			'has_play_lists' => true,
			'subitems' => array()
		);
	};

	$custom_menu = '';
	if (count($custom_pl)) {
		$custom_menu .= '<li><a href="#" class="sub">Custom Lists</a>'."\n";
		$custom_menu .= '<ul>'."\n";

		foreach($custom_pl as $folder) {
			if ($folder['has_play_lists']) {
				$custom_menu .= getFolderMenu($events, $folder);
			};
		};

		$custom_menu .= '</ul>'."\n";
		$custom_menu .= '</li>'."\n\n\n";
	};
	$filename = PLAYLIST_DIRECTORY_PATH.'playlistcustommenu.htm';
	if ($handle = fopen($filename, 'w')) {
		fwrite($handle, $custom_menu);
		fclose($handle);
	};


	$filename = PLAYLIST_DIRECTORY_PATH.'feature.xml';
	if ($handle = fopen($filename, 'w')) {
		fwrite($handle, '<?xml version="1.0" encoding="UTF-8"?>'."\n");
		fwrite($handle, '<events>'."\n");
		fwrite($handle, $events[0]."\n".join("\n", $events)."\n");
		fwrite($handle, '</events>'."\n");
		fclose($handle);
	};


} else if (isset($_POST['scan_selected'])) {
	$txt = join('', file(PLAYLIST_DIRECTORY_PATH.$_POST['play_list_file']));

	$mp3_folder = array();
	preg_match('/.*<location>(.+)<\/location>.*/Ui', $txt, $mp3_folder);
	$mp3_folder = str_replace(MP3_DIRECTORY_URL, '', $mp3_folder[1]);
	$mp3_folder = split('/', $mp3_folder);
	unset($mp3_folder[count($mp3_folder)-1]);
	$mp3_folder = join('/', $mp3_folder).'/';

	$dir_name = str_replace('playlist', '', $_POST['play_list_file']);
	$dir_name = str_replace('.xspf', '', $dir_name);

	print MP3_DIRECTORY_URL.$mp3_folder
		.' - '
		.create_playlist(
			MP3_DIRECTORY_PATH.rawurldecode($mp3_folder),
			MP3_DIRECTORY_URL.$mp3_folder,
			$dir_name
		)
		.' files found<br>'
	."\n";
}
?>

<center><br><br>
<b>Playlist Scanner</b>
<br><br>
Update an individual playlist file or scan and update all files and folders.<br><br>
<form method="post">
Update single playlist file:
<select name='play_list_file'>
<option></option>
<?PHP

$files = getDirFiles(PLAYLIST_DIRECTORY_PATH, 'xspf');
foreach ($files as $file) {
	?>
	<option value="<?=htmlspecialchars($file);?>"><?=$file;?></option>
	<?PHP
}


?>
</select>
<center><br>

&nbsp;<input type="submit" name="scan_selected" value="Scan Selected"> &nbsp; <input type="submit" name="scan_all" value="Scan All">
</form>

</body>
</html>